import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.io.Writer;
import java.net.MalformedURLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Scanner;

import com.gargoylesoftware.htmlunit.FailingHttpStatusCodeException;
import com.gargoylesoftware.htmlunit.WebClient;
import com.gargoylesoftware.htmlunit.html.HtmlForm;
import com.gargoylesoftware.htmlunit.html.HtmlPage;
import com.gargoylesoftware.htmlunit.html.HtmlSubmitInput;
import com.gargoylesoftware.htmlunit.html.HtmlTextInput;


public class PrefixedVerbsFrequency {

	ArrayList<ArrayList<String>> verbs = new ArrayList<ArrayList<String>> ();
	ArrayList<String> prefixes = new ArrayList<String>();
	ArrayList<String> prepositions = new ArrayList<String>();
	
	String verbsFile = "/home/ivelina/Zara/izvadki-forms";
	String prefixesFile = "/home/ivelina/Zara/pref";
	String prepositionsFile = "/home/ivelina/Zara/prep";
	String resultsFreqFile = "/home/ivelina/Zara/resultsFreq1.txt";
	String resultsFreqAllFile = "/home/ivelina/Zara/resultsFreqAll1.txt";
	String resultsFile = "/home/ivelina/Zara/results1.html";

	String exceptionsFile = "/home/ivelina/Zara/exceptions.txt";
	String exceptionsResultsFile = "/home/ivelina/Zara/resultsExceptions.txt";
	String exceptionsFreqResultsFile = "/home/ivelina/Zara/resultsFreqExceptions.txt";

	HashMap<String,Integer> frequencies = new HashMap<String,Integer>();
	HashMap<String,HashMap<String, Integer>> freqWithPrepositions = new HashMap<String,HashMap<String, Integer>>();
	
	ArrayList<String> prepsready  = new ArrayList<String>();
	
	public static void main(String[] args) {
		
		PrefixedVerbsFrequency pvf = new PrefixedVerbsFrequency();
		
//		pvf.getOriginal();
//		pvf.getExceptions();
	
		pvf.getOriginalWithPreposition();
		
	}
	
	public void getOriginal(){
		
		
		try {
			Scanner sv = new Scanner(new File(verbsFile), "UTF-8");
			Scanner sp = new Scanner(new File(prefixesFile), "UTF-8");
			
			Writer wrFreq = new OutputStreamWriter(new FileOutputStream(resultsFreqFile), "UTF-8");
			Writer wr = new OutputStreamWriter(new FileOutputStream(resultsFile), "UTF-8");
			
			while (sv.hasNextLine()){
				
				String l = sv.nextLine().trim(); 
				if (l.length()<1) continue;
				
				String[] forms = l.split("[\t ]");
				ArrayList<String> vforms = new ArrayList<String>();
				
				for (String f : forms) if (!f.trim().equals("")) vforms.add(f.trim());
				verbs.add(vforms);
				
			}
			while (sp.hasNextLine()){
				
				String l = sp.nextLine().trim(); 
				if (l.length()<1) continue;
				prefixes.add(l);
				
			}
		
			sv.close();
			sp.close();
			
			
			for (ArrayList<String> verb : verbs) {
				for (String v : verb){
				
					for (String p : prefixes) {
						String word = p + v;
						getFrequenciesFromBNK(word, wrFreq,wr);
						
					}
				
				}

			}
			
			wr.flush();
			wr.close();
			wrFreq.flush();
			wrFreq.close();
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	public void getOriginalWithPreposition(){
		
		
		try {
			Scanner sv = new Scanner(new File(verbsFile), "UTF-8");
			Scanner sp = new Scanner(new File(prefixesFile), "UTF-8");
			Scanner sprep = new Scanner(new File(prepositionsFile), "UTF-8");
			
			Writer wrFreq = new OutputStreamWriter(new FileOutputStream(resultsFreqFile,true), "UTF-8");
			Writer wr = new OutputStreamWriter(new FileOutputStream(resultsFile,true), "UTF-8");
			Writer wrAll = new OutputStreamWriter(new FileOutputStream(resultsFreqAllFile,true), "UTF-8");

			
			Writer wrFreq1 = new OutputStreamWriter(new FileOutputStream(resultsFreqFile.replace(".txt", ".html"),true), "UTF-8");
			Writer wrAll1 = new OutputStreamWriter(new FileOutputStream(resultsFreqAllFile.replace(".txt", ".html"),true), "UTF-8");

			while (sv.hasNextLine()){
				
				String l = sv.nextLine().trim(); 
				if (l.length()<1) continue;
				
				String[] forms = l.split("[\t ]");
				ArrayList<String> vforms = new ArrayList<String>();
				
				for (String f : forms) if (!f.trim().equals("")) vforms.add(f.trim());
				verbs.add(vforms);
				
			}
			while (sp.hasNextLine()){
				
				String l = sp.nextLine().trim(); 
				if (l.length()<1) continue;
				prefixes.add(l);
				
			}
		
			while (sprep.hasNextLine()){
				
				String l = sprep.nextLine().trim(); 
				if (l.length()<1) continue;
				prepositions.add(l);
				
			}

			sv.close();
			sp.close();
			sprep.close();
			
			wrAll1.write("<table border=1>\n<tr><td></td><td>total</td>");
			wrAll.write("\ttotal");
			wrFreq1.write("<table border=1>\n");
			
			for (String prep : prepositions) {
				wrAll.write("\t"+prep);
				wrAll1.write("<td>"+prep+"</td>");
			}
			
			wrAll.write("\n");
			wrAll.flush();

			wrAll1.write("</tr>\n");
			wrAll1.flush();
			
			boolean proceed = false;

			for (ArrayList<String> verb : verbs) {
				
				String v = verb.get(0);
				
				prepsready  = new ArrayList<String>();
								
				for (String p : prefixes) {
					
					if (v.equals("плета") && p.equals("раз")) proceed = true;
					if (!proceed) continue;
					
					String word = p + v;
					
					int verbfreq = 0;
					int method = 1;
					
					int freqBNK = getFrequenciesFromBNK(word, null, null);
					if (freqBNK > 50) {
						
						method = 0;
						verbfreq += freqBNK;
					} else {
					
						for (String v1 : verb){
	
							freqBNK = getFrequenciesFromBNK1(p+v1, null, null);
							verbfreq += freqBNK;
							
						}
					}

					if (verbfreq==0) continue; // next prefix
					
					wrAll.write(word + "\t"+verbfreq);
					wrAll.flush();

					wrAll1.write("<tr><td>"+word+"</td><td>"+verbfreq+"</td>");
					wrAll1.flush();
					
					for (String prep : prepositions) {
						if (method == 0) getFrequenciesWithPreposition(p+v, prep, 0,3, wr);
						
						if (method == 1) {
							for (String v1 : verb){
								getFrequenciesWithPreposition1(p+v, p+v1, prep, 0,3, wr);
							}
						}
						
						if (!prepsready.contains(prep)) prepsready.add(prep);

					}
					
					HashMap<String,Integer> freqprep = freqWithPrepositions.get(word);
					
					String l1 = "\ttotal";
					String l2 = word+"\t"+verbfreq;
					String l1a = "<table border=1><tr><td></td><td>total</td>";
					String l2a = "<tr><td>"+word+"</td><td>"+verbfreq+"</td>";
					for (String prep : prepositions) {
						if (freqprep.containsKey(prep) && freqprep.get(prep)>0) {
							l1 += "\t" + prep;
							l2 += "\t" + freqprep.get(prep);

							l1a += "<td>" + prep+"</td>";
							l2a += "<td>" + freqprep.get(prep)+"</td>";

							wrAll.write("\t"+freqprep.get(prep));
							wrAll.flush();
							wrAll1.write("<td>"+freqprep.get(prep)+"</td>");
							wrAll1.flush();
						} else {
							wrAll.write("\t0");
							wrAll.flush();
							wrAll1.write("<td>0</td>");
							wrAll1.flush();
							
						}
					}
					
					
					wrFreq.write(l1+"\n"+l2+"\n\n");
					wrFreq.flush();
					wrFreq1.write(l1a+"</tr>\n"+l2a+"</tr>\n</table>\n\n");
					wrFreq1.flush();
					
					wrAll.write("\n");
					wrAll.flush();
					wrAll1.write("</tr>\n");
					wrAll1.flush();
					
				}

			
			}
			
			wrAll1.write("</table>\n");
			wrAll1.flush();

			
			wr.flush();
			wr.close();
			wrFreq.flush();
			wrFreq.close();
			wrAll.flush();
			wrAll.close();
			wrFreq1.flush();
			wrFreq1.close();
			wrAll1.flush();
			wrAll1.close();
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	public void getExceptions(){
		
		
		try {
			Scanner se = new Scanner(new File(exceptionsFile), "UTF-8");
			
			Writer wrFreq = new OutputStreamWriter(new FileOutputStream(exceptionsFreqResultsFile), "UTF-8");
			Writer wr = new OutputStreamWriter(new FileOutputStream(exceptionsResultsFile), "UTF-8");
			
			while (se.hasNextLine()){
				
				String l = se.nextLine().trim(); 
				if (l.length()<1) continue;
				
				getFrequenciesFromBNK(l, wrFreq,wr);

			}
			
			se.close();
			wr.flush();
			wr.close();
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	public int getFrequenciesFromBNK(String line, Writer wrfreq, Writer wr) {
		
		String[] exs = line.split("[ \t]");
		
  		String text = exs[0]+"/F/";
  		
  		for (int i=1; i<exs.length; i++) {
  			text += "&!"+exs[i];
  		}
 		
	    final WebClient webClient = new WebClient();

	    // Get the first page
	    HtmlPage page1;
		try {
			page1 = webClient.getPage("http://search.dcl.bas.bg/");

//			System.out.println(page1.asText());
			
    	    // Get the form that we are dealing with and within that form, 
    	    // find the submit button and the field that we want to change.
    	    final HtmlForm form = page1.getForms().get(0);

    	    final HtmlSubmitInput button = form.getInputByValue("Search");
    	    final HtmlTextInput textField = form.getInputByName("query");

    	    // Change the value of the text field
    	    textField.setValueAttribute(text);

    	    // Now submit the form by clicking the button and get back the second page.
    	    final HtmlPage page2 = button.click();
    	    
    	    String re = page2.asText();
    	    
    	    if (re.contains("No results.")) {
//        	    wrfreq.write(exs[0]+"\t"+0+"\n");
//        	    wrfreq.flush();

        	    return 0;
    	    }
    	    
    	    int i1 = re.indexOf("30 random results from") + "30 random results from".length();
    	    int i2 = i1 + re.substring(i1).indexOf("found");
    	    int i3 = i2 + "found.".length();
    	    
    	    int fr = Integer.valueOf(re.substring(i1,i2).trim());
    	    String t = re.substring(i3).replaceAll("\\+", "\n");
    	    
//    	    wrfreq.write(exs[0]+"\t"+fr+"\n");
//    	    wrfreq.flush();

//    	    wr.write("*********** " + exs[0] + " " + fr + " ***********\n"+t+"\n\n");
//    	    wr.flush();

    	    
    	    webClient.closeAllWindows();
    	    return fr;

		} catch (FailingHttpStatusCodeException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (MalformedURLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		

		return 0;
}
	
	public int getFrequenciesFromBNK1(String line, Writer wrfreq, Writer wr) {
		
		String[] exs = line.split("[ \t]");
		
  		String text = exs[0];
  		
  		for (int i=1; i<exs.length; i++) {
  			text += "&!"+exs[i];
  		}
 		
	    final WebClient webClient = new WebClient();

	    // Get the first page
	    HtmlPage page1;
		try {
			page1 = webClient.getPage("http://search.dcl.bas.bg/");

//			System.out.println(page1.asText());
			
    	    // Get the form that we are dealing with and within that form, 
    	    // find the submit button and the field that we want to change.
    	    final HtmlForm form = page1.getForms().get(0);

    	    final HtmlSubmitInput button = form.getInputByValue("Search");
    	    final HtmlTextInput textField = form.getInputByName("query");

    	    // Change the value of the text field
    	    textField.setValueAttribute(text);

    	    // Now submit the form by clicking the button and get back the second page.
    	    final HtmlPage page2 = button.click();
    	    
    	    String re = page2.asText();
    	    
    	    if (re.contains("No results.")) {
//        	    wrfreq.write(exs[0]+"\t"+0+"\n");
//        	    wrfreq.flush();

        	    return 0;
    	    }
    	    
    	    int i1 = re.indexOf("30 random results from") + "30 random results from".length();
    	    int i2 = i1 + re.substring(i1).indexOf("found");
    	    int i3 = i2 + "found.".length();
    	    
    	    int fr = Integer.valueOf(re.substring(i1,i2).trim());
    	    String t = re.substring(i3).replaceAll("\\+", "\n");
    	    
//    	    wrfreq.write(exs[0]+"\t"+fr+"\n");
//    	    wrfreq.flush();

//    	    wr.write("*********** " + exs[0] + " " + fr + " ***********\n"+t+"\n\n");
//    	    wr.flush();

    	    
    	    webClient.closeAllWindows();
    	    return fr;

		} catch (FailingHttpStatusCodeException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (MalformedURLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		

		return 0;
}


	
	public void getFrequenciesWithPreposition(String word, String prep, int distmin, int distmax, Writer wr) {
		
		String[] exs = word.split("[ \t]");
		
  		String text = exs[0]+"/F/";
  		
  		for (int i=1; i<exs.length; i++) {
  			text += "&!"+exs[i];
  		}
  		
  		text += " ["+distmin+","+distmax+"] ";
  		text += prep;
  		
  		text = "<"+text+">";
 		
	    final WebClient webClient = new WebClient();

	    // Get the first page
	    HtmlPage page1;
		try {
			page1 = webClient.getPage("http://search.dcl.bas.bg/");

//			System.out.println(page1.asText());
			
    	    // Get the form that we are dealing with and within that form, 
    	    // find the submit button and the field that we want to change.
    	    final HtmlForm form = page1.getForms().get(0);

    	    final HtmlSubmitInput button = form.getInputByValue("Search");
    	    final HtmlTextInput textField = form.getInputByName("query");

    	    // Change the value of the text field
    	    textField.setValueAttribute(text);
    	    
    	    System.out.println("Search request: "+text);
    	    
    	    // Now submit the form by clicking the button and get back the second page.
    	    final HtmlPage page2 = button.click();
    	    
    	    String re = page2.asText();
    	    
    	    HashMap<String, Integer> f1;
    	    if (freqWithPrepositions.containsKey(exs[0])) {
    	    	f1 = freqWithPrepositions.get(exs[0]);
    	    } else {
    	    	f1 = new HashMap<String, Integer>();
    	    }
    	    
    	    int fr = 0;
    	    
    	    if (re.contains("No results.")) {
    	    	
    	    	fr = 0;
    	    	
    	    } else {
    	    
	    	    int i1 = re.indexOf("30 random results from") + "30 random results from".length();
	    	    int i2 = i1 + re.substring(i1).indexOf("found");
	    	    int i3 = i2 + "found.".length();
	    	    
	    	    fr = Integer.valueOf(re.substring(i1,i2).trim());
	    	    String t = re.substring(i3).replaceAll("\\+", "\n");
	    	    
	    	    t = makeResultIntoHTML(text,t, word, prep,distmin, distmax);
	    	    wr.write(t);
	    	    wr.flush();
    	    
    	    }
    	    
    	    f1.put(prep, fr);
    	    freqWithPrepositions.put(exs[0], f1);
    	    
 
    	    webClient.closeAllWindows();

		} catch (FailingHttpStatusCodeException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (MalformedURLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		


}
	
	public void getFrequenciesWithPreposition1(String mainword, String word, String prep, int distmin, int distmax, Writer wr) {
		
		String[] exs = word.split("[ \t]");
		
  		String text = exs[0];
  		
  		for (int i=1; i<exs.length; i++) {
  			text += "&!"+exs[i];
  		}
  		
  		text += " ["+distmin+","+distmax+"] ";
  		text += prep;
  		
  		text = "<"+text+">";
 		
	    final WebClient webClient = new WebClient();

	    // Get the first page
	    HtmlPage page1;
		try {
			page1 = webClient.getPage("http://search.dcl.bas.bg/");

//			System.out.println(page1.asText());
			
    	    // Get the form that we are dealing with and within that form, 
    	    // find the submit button and the field that we want to change.
    	    final HtmlForm form = page1.getForms().get(0);

    	    final HtmlSubmitInput button = form.getInputByValue("Search");
    	    final HtmlTextInput textField = form.getInputByName("query");

    	    // Change the value of the text field
    	    textField.setValueAttribute(text);
    	    
    	    System.out.println("Search request: "+text);
    	    
    	    // Now submit the form by clicking the button and get back the second page.
    	    final HtmlPage page2 = button.click();
    	    
    	    String re = page2.asText();
    	    
    	    HashMap<String, Integer> f1;
    	    if (freqWithPrepositions.containsKey(mainword)) {
    	    	f1 = freqWithPrepositions.get(mainword);
    	    } else {
    	    	f1 = new HashMap<String, Integer>();
    	    }
    	    
    	    int fr = 0;
    	    
    	    if (re.contains("No results.")) {
    	    	
    	    	fr = 0;
    	    	
    	    } else {
    	    
	    	    int i1 = re.indexOf("30 random results from") + "30 random results from".length();
	    	    int i2 = i1 + re.substring(i1).indexOf("found");
	    	    int i3 = i2 + "found.".length();
	    	    
	    	    fr = Integer.valueOf(re.substring(i1,i2).trim());
	    	    String t = re.substring(i3).replaceAll("\\+", "\n");
	    	    
	    	    if(!prepsready.contains(prep)) {
		    	    t = makeResultIntoHTML(text,t, word, prep,distmin, distmax);
		    	    wr.write(t);
		    	    wr.flush();
		    	    if(fr>30) prepsready.add(prep);
	    	    }
    	    
    	    }
    	    
    	    int prepfr = 0;
    	    if (f1.containsKey(prep)) {
    	    	prepfr = f1.get(prep);
    	    } else {
    	    	prepfr = 0;
    	    }
    	    f1.put(prep, prepfr+fr);
    	    
    	    freqWithPrepositions.put(mainword, f1);
    	    
 
    	    webClient.closeAllWindows();

		} catch (FailingHttpStatusCodeException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (MalformedURLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		


}
	
	String makeResultIntoHTML(String text, String t, String word, String prep, int min, int max) {
		String result = "";
		
		result = "<h4>" + text.replace("<", "").replace(">", "") + "</h4>\n\n";
		
		String[] lines = t.split("\n");
		
		for (String line : lines) {
	
			line = line.trim();
			if (line.equals("")) continue;
			
			result += "<p>";
			
			String[] words = line.split(" ");
			
line:		for (int i = 0; i<words.length; i++) {
				if (words[i].trim().toLowerCase().startsWith(word.substring(0,4))) {
					
					for (int k = min+1; k< max+2; k++){
						if (i+k<words.length && words[i+k].trim().equalsIgnoreCase(prep)){
							result += "<font color=\"red\">" + words[i] + "</font> ";
							
							for (int j=i+1; j<i+k; j++) result += words[j]+" ";
							
							result += "<font color=\"red\">" + words[i+k] + "</font> ";
							
							i = i+k;
							continue line;
						}
					}
				}
				
				result += words[i] + " ";
			}
			
			result += "\n\n";
		}
		
		
		
		return result;
		
	}

}
