package bg.bas.dcl.CorpusTools;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Scanner;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.bootstrap.DOMImplementationRegistry;
import org.w3c.dom.ls.DOMImplementationLS;
import org.w3c.dom.ls.LSSerializer;
import org.xml.sax.SAXException;

import bg.bas.dcl.mwe.entities.Chunk;
import bg.bas.dcl.mwe.entities.MWECandidate;
import bg.bas.dcl.mwe.entities.SentenceCl;
import bg.bas.dcl.mwe.entities.Word;
import bg.bas.dcl.mwe.entities.WordAlphabetic;
import bg.bas.dcl.mwe.lists.Index;
import bg.bas.dcl.mwe.lists.IndexAlphabetical;
import bg.bas.dcl.mwe.lists.IndexLexicon;
import bg.bas.dcl.mwe.lists.SyntacticConstructions;
import bg.bas.dcl.mwe.lists.TokenToLemmaLexicon;

public class CorpusMWETagger {

//	static Index index = new Index();
	static IndexAlphabetical indexAlphabetical = new IndexAlphabetical();
	static long mwectr = 1;
	
	static HashMap<String,String> mweDicts = new HashMap<String,String>();

	static IndexAlphabetical indexMWE = new IndexAlphabetical();
	static String mainPath = "";

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

		mainPath = args[0];
//		String filepath = args[1];
		
		String path = mainPath + "/xml-verified-final";
		String filepath = mainPath + "/lexicon/mwes_ALL_synt_filter_plus1";
		
//		indexTexts(path);
		
//		index.printTokenFreq("/home/ivelina/svn_corpus/forTheTagger/tokenList");
//		index.printLemmaFreq("/home/ivelina/svn_corpus/forTheTagger/lemmaList");
//		index.printWordFreq("/home/ivelina/svn_corpus/forTheTagger/wordList");

//		indexAlphabetical.printTokenFreq("/home/ivelina/svn_corpus/forTheTagger/tokenList2");
//		indexAlphabetical.printLemmaFreq("/home/ivelina/svn_corpus/forTheTagger/lemmaList2");
		
//		correctChunks(path);
		
//		extractMWECandidates(path);

		
		readMWEDictFromFile(filepath);
		
//		markMWEsInFiles(path);
		String newpath = mainPath + "/xml-verified-marked-plus1";
		extractMWECandidatesPlusFreq(newpath);
	}
	
	static public void readMWEDictFromFile(String path) {
		
		Scanner scan;
		
		try {
			scan = new Scanner(new File(path),"UTF-8");
			
			while (scan.hasNextLine()) {
				String l = scan.nextLine();
				
				String type = "";
				
				if (l.startsWith("0") || l.startsWith("1") ||
						l.startsWith("2") ||l.startsWith("3")||
						l.startsWith("4")||l.startsWith("5")||
						l.startsWith("6")||l.startsWith("7")||
						l.startsWith("8")||l.startsWith("9")||
						l.startsWith("A")||l.startsWith("B")||
						l.startsWith("X")) {
					type = l.substring(0,1);
					l  = l.substring(1);
				} else {
					l = "7";
				}
				
				
				String[] words = l.split(" ");
				String lemmas = "";
				String model = "";
				
				for (int i=0; i<words.length; i=i+2) {
					lemmas += words[i] + " ";
				}
				lemmas = lemmas.trim();
				
				for (int i=1; i<words.length; i=i+2) {
					model += words[i];
				}
				
				mweDicts.put(lemmas, type);
			}
			
			System.out.println("MWEs read ... " + mweDicts.size());
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	

	  /**
	   * Recursively walk a directory tree and return a List of all
	   * Files found; the List is sorted using File.compareTo().
	   *
	   * @param aStartingDir is a valid directory, which can be read.
	   */
	   static public List<File> getFileListing(
	     File aStartingDir
	   ) throws FileNotFoundException {
	     validateDirectory(aStartingDir);
	     List<File> result = getFileListingNoSort(aStartingDir);
	     Collections.sort(result);
	     return result;
	   }

	   // PRIVATE //
	   static private List<File> getFileListingNoSort(
	     File aStartingDir
	   ) throws FileNotFoundException {
	     List<File> result = new ArrayList<File>();
	     File[] filesAndDirs = aStartingDir.listFiles();
	     List<File> filesDirs = Arrays.asList(filesAndDirs);
	     for(File file : filesDirs) {
	       result.add(file); //always add, even if directory
	       if ( ! file.isFile() ) {
	         //must be a directory
	         //recursive call!
	         List<File> deeperList = getFileListingNoSort(file);
	         result.addAll(deeperList);
	       }
	     }
	     return result;
	   }

	   /**
	   * Directory is valid if it exists, does not represent a file, and can be read.
	   */
	   static private void validateDirectory (
	     File aDirectory
	   ) throws FileNotFoundException {
	     if (aDirectory == null) {
	       throw new IllegalArgumentException("Directory should not be null.");
	     }
	     if (!aDirectory.exists()) {
	       throw new FileNotFoundException("Directory does not exist: " + aDirectory);
	     }
	     if (!aDirectory.isDirectory()) {
	       throw new IllegalArgumentException("Is not a directory: " + aDirectory);
	     }
	     if (!aDirectory.canRead()) {
	       throw new IllegalArgumentException("Directory cannot be read: " + aDirectory);
	     }
	   }

		static void makeParent(String path,String mainPath){
			  String parent = (new File(path)).getParent();
			 
			  if ((new File(parent)).exists()) return;
			  
			  if (!parent.equals(mainPath)) {
				  makeParent(parent, mainPath);
			  } 
			  
			  (new File(parent)).mkdir();
			  
		}
		
		public static void indexTexts(String path){
			
		    File startingDirectory= new File(path);
		    List<File> files = null;
		    try{
		    	files = getFileListing(startingDirectory);
		    	System.out.println(files.size());
		    } catch(Exception e){
		    	System.err.println("GET listing error");
		    }

		    int all = 0;


		    
		    for(File file : files ){
			      if (file.isFile()){
			    	  
			    	  
			    	  if (file.getName().startsWith("._")) continue;
			    	  if (file.getName().endsWith("~")) continue;
			    	  
						try {

							DocumentBuilderFactory builderFactory = DocumentBuilderFactory.newInstance();
				    		DocumentBuilder builder = builderFactory.newDocumentBuilder();
				    		Document document = builder.parse(new FileInputStream(file.getAbsolutePath()));
				    		
				    		Element rootElement = document.getDocumentElement();
				    		
					    	DOMImplementationRegistry registry = DOMImplementationRegistry.newInstance();
					    	DOMImplementationLS lsImpl = 
					    	   (DOMImplementationLS)registry.getDOMImplementation("LS");
					    	LSSerializer serializer = lsImpl.createLSSerializer();
		
					    	NodeList nodes = rootElement.getChildNodes();
					    	SentenceCl sen = new SentenceCl();
						    boolean validSent = false;
						    boolean errorSent = false;
						    
						    System.out.println("Processing " + file.getAbsolutePath());
		
					    	for(int i=0; i<nodes.getLength(); i++){
						    	  Node node = nodes.item(i);
						    	  if(node instanceof Element){
						    		  Element child = (Element) node;
						    		  
						    		  String token = child.getAttribute("w");
						    		  String lemma = child.getAttribute("l");
						    		  
						    		  indexAlphabetical.addWord(token, lemma);
						    	  }
					    	}
				    		System.out.println(nodes.getLength()+ "\t" + file.length());
				    		all += nodes.getLength()-1;

			    	  
						} catch (FileNotFoundException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						} catch (SAXException e) {
							// TODO Auto-generated catch block
					    	  System.out.println(file.length());
							e.printStackTrace();
							System.err.println(file.getAbsolutePath());
						} catch (IOException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						} catch (ParserConfigurationException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						} catch (ClassCastException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						} catch (ClassNotFoundException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						} catch (InstantiationException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						} catch (IllegalAccessException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}

			      }
			}
		    
		    System.err.println("All: " + all);

		}

		
		public static void correctChunks(String path){
			
		    File startingDirectory= new File(path);
		    List<File> files = null;
		    try{
		    	files = getFileListing(startingDirectory);
		    	System.out.println(files.size());
		    } catch(Exception e){
		    	System.err.println("GET listing error");
		    }

		    int all = 0;
		    int currentChunk = 0;
		    int previousChunk = 0;

		    SyntacticConstructions s = new  SyntacticConstructions();
		    
		    for(File file : files ){
			      if (file.isFile()){
			    	  
			    	  
			    	  if (file.getName().startsWith("._")) continue;
			    	  if (file.getName().endsWith("~")) continue;
			    	  
						try {

							DocumentBuilderFactory builderFactory = DocumentBuilderFactory.newInstance();
				    		DocumentBuilder builder = builderFactory.newDocumentBuilder();
				    		Document document = builder.parse(new FileInputStream(file.getAbsolutePath()));
				    		
				    		Element rootElement = document.getDocumentElement();
				    		
					    	DOMImplementationRegistry registry = DOMImplementationRegistry.newInstance();
					    	DOMImplementationLS lsImpl = 
					    	   (DOMImplementationLS)registry.getDOMImplementation("LS");
					    	LSSerializer serializer = lsImpl.createLSSerializer();
		
					    	NodeList nodes = rootElement.getChildNodes();
						    
						    System.out.println("Processing " + file.getAbsolutePath());
						    
						    String fname = file.getAbsolutePath().replace("/xml-verified-final/", "/xml-verified-final-final/");
						    makeParent(fname, "/");
						    
						    Writer wr = new OutputStreamWriter(new FileOutputStream(fname), "UTF-8");
						    wr.write("<?xml version=\"1.0\" ?><text current=\"0\">\n");
						    
						    int i = 0;
					    	
					    	String chunkStruct = "";

						    while (i<nodes.getLength()) {

						    	WordAlphabetic word = new WordAlphabetic();
						    	
						    	Chunk chunk = new Chunk();
						    	chunk.id = "" +  currentChunk;
						    	currentChunk++;
						   	
						    	while (i<nodes.getLength()){
						    		
						    		
							    	Node node = nodes.item(i);
							    	
							    	if(node instanceof Element){
							    		
							    		  Element child = (Element) node;
							    		  
							    		  String token = child.getAttribute("w");
							    		  String lemma = child.getAttribute("l");

							    		  String pos = child.getAttribute("pos");
							    		  
//							    		  System.out.println("CHECK " + token +"\tchunk: "+ chunk.size());
							    		  
							    		  if (pos == null) {
							    			  i++;
							    			  break;
							    		  }
							    		  

								    	
							    		  							    		  
							    		  word = new WordAlphabetic(indexAlphabetical.tokenIndex,indexAlphabetical.lemmaIndex);
							    		  
							    		  int[] inds = indexAlphabetical.addWord(token, lemma);

//							    		  System.out.println(token + "inds: " + inds[0] + "\t" + inds[1] + "\t" + inds[2] + "\t" + inds[3]);

							    		  word.word[0] = inds[0];
							    		  word.word[1] = inds[1];
							    		  word.lemma[0] = inds[2];
							    		  word.lemma[1] = inds[3];
							    		  
							    		  word.sen = ""+currentChunk;
							    		  word.pos = pos;


							    		  if (pos.equals("U")) {
							    			  wr.write(word.toXML());
							    			  i++;
							    			  break;
							    		  }

							    		  if (word.pos != null) {
							    			  chunk.add(word);

//							    			  System.out.println("token "+ token + "\t" +  indexAlphabetical.tokenIndex.get(word.word[0]).get(word.word[1]));
							    			  
							    			  wr.write(word.toXML());
							    		  }
							    	} 
							    	
							    	
							    	i++;
							    	
						    	}
						    	
						    	// process chunk
						    	if (chunk.size() > 1) {
						    		
						    		
						    		String chStr = chunk.getStruct();
						    		String match = "";
						    		System.out.println(chStr);
						    		
						    		for (String str : s){
						    			if (chStr.contains(str)) {
						    				int index = chStr.indexOf(str);
						    				
						    				int length = str.length();
						    				
						    				MWECandidate c = new MWECandidate();
						    				
						    				for (int j = 0; j<length; j++) {
						    					c.phrase.add(chunk.get(index + j));
						    				}
						    				
						    				System.out.println();
						    				
						    			}
						    		}
						    		
						    	}
						    	

//						    	i++;
						    }
						    

						    //System.out.println(nodes.getLength()+ "\t" + file.length());
				    		//all += nodes.getLength()-1;

					  wr.write("</text>");
			    	  wr.flush();
			    	  wr.close();
						    
						} catch (FileNotFoundException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						} catch (SAXException e) {
							// TODO Auto-generated catch block
					    	  System.out.println(file.length());
							e.printStackTrace();
							System.err.println(file.getAbsolutePath());
						} catch (IOException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						} catch (ParserConfigurationException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						} catch (ClassCastException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						} catch (ClassNotFoundException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						} catch (InstantiationException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						} catch (IllegalAccessException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}

					
//					      System.exit(0);
			      }
			      
			     
			}
		    

		}

		
		public static void extractMWECandidates(String path){
			
		    File startingDirectory= new File(path);
		    List<File> files = null;
		    try{
		    	files = getFileListing(startingDirectory);
		    	System.out.println(files.size());
		    } catch(Exception e){
		    	System.err.println("GET listing error");
		    }

		    int all = 0;
		    int currentChunk = 0;
		    int previousChunk = 0;

		    SyntacticConstructions s = new  SyntacticConstructions();
		    
		    Writer wr;
		    HashMap<String,Writer> wrs = new HashMap<String,Writer>();
		    
			try {
				wr = new OutputStreamWriter(new FileOutputStream(mainPath + "/mwe_candidates"), "UTF-8");

	    		for (String str : s){	    		
	    			Writer wr1 = new OutputStreamWriter(new FileOutputStream(mainPath + "/mwe_candidates_"+str), "UTF-8");
	    			wrs.put(str, wr1);
	    		}
		    
		    for(File file : files ){
			      if (file.isFile()){
			    	  
			    	  
			    	  if (file.getName().startsWith("._")) continue;
			    	  if (file.getName().endsWith("~")) continue;
			    	  

							DocumentBuilderFactory builderFactory = DocumentBuilderFactory.newInstance();
				    		DocumentBuilder builder = builderFactory.newDocumentBuilder();
				    		Document document = builder.parse(new FileInputStream(file.getAbsolutePath()));
				    		
				    		Element rootElement = document.getDocumentElement();
				    		
					    	DOMImplementationRegistry registry = DOMImplementationRegistry.newInstance();
					    	DOMImplementationLS lsImpl = 
					    	   (DOMImplementationLS)registry.getDOMImplementation("LS");
					    	LSSerializer serializer = lsImpl.createLSSerializer();
		
					    	NodeList nodes = rootElement.getChildNodes();
						    
						    System.out.println("Processing " + file.getAbsolutePath());
						    
						    
						    int i = 0;
					    	
					    	String chunkStruct = "";
					    	Chunk chunk = new Chunk();
					    	WordAlphabetic word = new WordAlphabetic();

						    while (i<nodes.getLength()) {

						    	
						    	
						   	
						    	while (i<nodes.getLength()  && currentChunk == previousChunk){
						    		
						    		
							    	Node node = nodes.item(i);
							    	
							    	if(node instanceof Element){
							    		
								    	if (word.pos != null) chunk.add(word);

							    		
							    		  Element child = (Element) node;
							    		  
							    		  String token = child.getAttribute("w");
							    		  String lemma = child.getAttribute("l");

							    		  String pos = child.getAttribute("pos");
							    		  String sen = child.getAttribute("sen");
							    		  							    		  							    		  
							    		  word = new WordAlphabetic(indexAlphabetical.tokenIndex,indexAlphabetical.lemmaIndex);
							    		  
							    		  int[] inds = indexAlphabetical.addWord(token, lemma);

//							    		  System.out.println(token + "inds: " + inds[0] + "\t" + inds[1] + "\t" + inds[2] + "\t" + inds[3]);

							    		  word.word[0] = inds[0];
							    		  word.word[1] = inds[1];
							    		  word.lemma[0] = inds[2];
							    		  word.lemma[1] = inds[3];
							    		  
							    		  word.pos = pos;
							    		  word.sen = sen;
							    		  currentChunk = Integer.valueOf(sen);
							    	} 
							    	
							    	
							    	i++;
							    	
						    	}
						    	
						    	// process chunk
						    	if (chunk.size() > 1) {
						    		
						    		
						    		String chStr = chunk.getStruct();
						    		String match = "";
						    		System.out.println(chStr);
						    		
						    		for (String str : s){
						    			String chStr1 = chStr;
						    			int cutAt = 0;
						    			
						    			while (chStr1.contains(str)) {
						    				int index = chStr1.indexOf(str);
						    				int length = str.length();
						    				
						    				System.out.println(str + "\t" + chStr1);
						    				
						    				MWECandidate c = new MWECandidate();
						    				
						    				for (int j = 0; j<length; j++) {
						    					c.phrase.add(chunk.get(cutAt + index + j));
//						    					System.out.println(chunk.id);
//						    					System.out.print(indexAlphabetical.tokenIndex.get(chunk.get(index + j).word[0]).get(chunk.get(index + j).word[1]) + " ");
						    				}
						    				
						    				System.out.println(c.getLemmaMWE() + "\t" + c.getMWE());
						    				wr.write(c.getLemmaMWE() + "\t" + c.getMWE()+ "\n");
						    				wr.flush();
						    				wrs.get(str).write(c.getLemmaMWE() + "\t" + c.getMWE()+ "\n");
						    				wrs.get(str).flush();
						    				
						    				chStr1 = chStr1.substring(index+1);
						    				cutAt += index+1;
						    			}
						    		}
						    		
						    	}
						    	
						    	chunk = new Chunk();
						    	chunk.id = ""+currentChunk;
						    	previousChunk = currentChunk;

//						    	i++;
						    }
						    

						    //System.out.println(nodes.getLength()+ "\t" + file.length());
				    		//all += nodes.getLength()-1;


			      }
		    }
			
	    	  wr.flush();
	    	  wr.close();

			     
	    	  for (String str : s){
		    		
	    			wrs.get(str).flush();
	    			wrs.get(str).close();
	    		}
	    	  
			} catch (UnsupportedEncodingException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			} catch (FileNotFoundException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			} catch (SAXException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (ParserConfigurationException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (ClassCastException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (ClassNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (InstantiationException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IllegalAccessException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}


}

		
		public static void extractMWECandidatesPlusFreq(String path){
			
		    File startingDirectory= new File(path);
		    List<File> files = null;
		    try{
		    	files = getFileListing(startingDirectory);
		    	System.out.println(files.size());
		    } catch(Exception e){
		    	System.err.println("GET listing error");
		    }

		    int all = 0;
		    int currentChunk = 0;
		    int previousChunk = 0;

		    SyntacticConstructions s = new  SyntacticConstructions();
		    
		    Writer wr;
		    HashMap<String,HashMap<String,Integer>> constr = new HashMap<String,HashMap<String,Integer>>();
		    HashMap<String,Writer> wrs = new HashMap<String,Writer>();
		    
			try {
				wr = new OutputStreamWriter(new FileOutputStream(mainPath + "/mwe_candidates_plus1"), "UTF-8");

	    		for (String str : s){	    		
	    			HashMap<String,Integer> constr1 = new HashMap<String,Integer>();
	    			constr.put(str, constr1);
	    		}

		    
		    for(File file : files ){
			      if (file.isFile()){
			    	  
			    	  
			    	  if (file.getName().startsWith("._")) continue;
			    	  if (file.getName().endsWith("~")) continue;
			    	  

							DocumentBuilderFactory builderFactory = DocumentBuilderFactory.newInstance();
				    		DocumentBuilder builder = builderFactory.newDocumentBuilder();
				    		Document document = builder.parse(new FileInputStream(file.getAbsolutePath()));
				    		
				    		Element rootElement = document.getDocumentElement();
				    		
					    	DOMImplementationRegistry registry = DOMImplementationRegistry.newInstance();
					    	DOMImplementationLS lsImpl = 
					    	   (DOMImplementationLS)registry.getDOMImplementation("LS");
					    	LSSerializer serializer = lsImpl.createLSSerializer();
		
					    	NodeList nodes = rootElement.getChildNodes();
						    
						    System.out.println("Processing " + file.getAbsolutePath());
						    
						    
						    int i = 0;
					    	
					    	String chunkStruct = "";
					    	Chunk chunk = new Chunk();
					    	WordAlphabetic word = new WordAlphabetic();

						    while (i<nodes.getLength()) {

						    	
						    	
						   	
						    	while (i<nodes.getLength()  && currentChunk == previousChunk){
						    		
						    		
							    	Node node = nodes.item(i);
							    	
							    	if(node instanceof Element){
							    		
								    	if (word.pos != null) chunk.add(word);

							    		
							    		  Element child = (Element) node;
							    		  
							    		  String token = child.getAttribute("w");
							    		  String lemma = child.getAttribute("l");

							    		  String pos = child.getAttribute("pos");
							    		  String sen = child.getAttribute("sen");
							    		  							    		  							    		  
							    		  word = new WordAlphabetic(indexAlphabetical.tokenIndex,indexAlphabetical.lemmaIndex);
							    		  
							    		  int[] inds = indexAlphabetical.addWord(token, lemma);

//							    		  System.out.println(token + "inds: " + inds[0] + "\t" + inds[1] + "\t" + inds[2] + "\t" + inds[3]);

							    		  word.word[0] = inds[0];
							    		  word.word[1] = inds[1];
							    		  word.lemma[0] = inds[2];
							    		  word.lemma[1] = inds[3];
							    		  
							    		  word.pos = pos;
							    		  word.sen = sen;
							    		  currentChunk = Integer.valueOf(sen);
							    	} 
							    	
							    	
							    	i++;
							    	
						    	}
						    	
						    	// process chunk
						    	if (chunk.size() > 1) {
						    		
						    		
						    		String chStr = chunk.getStruct();
						    		String match = "";
						    		System.out.println(chStr);
						    		
						    		for (String str : s){
						    			String chStr1 = chStr;
						    			int cutAt = 0;
						    			
						    			while (chStr1.contains(str)) {
						    				int index = chStr1.indexOf(str);
						    				int length = str.length();
						    				
//						    				System.out.println(str + "\t" + chStr1);
						    				
						    				MWECandidate c = new MWECandidate();
						    				
						    				for (int j = 0; j<length; j++) {
						    					c.phrase.add(chunk.get(cutAt + index + j));
//						    					System.out.println(chunk.id);
//						    					System.out.print(indexAlphabetical.tokenIndex.get(chunk.get(index + j).word[0]).get(chunk.get(index + j).word[1]) + " ");
						    				}
						    				
//						    				System.out.println(c.getLemmaMWE() + "\t" + c.getMWE());
						    				String type = (mweDicts.containsKey(c.getLemmaMWE()))? mweDicts.get(c.getLemmaMWE()) : "Y";
						    				
						    				System.out.println(c.getLemmaMWE() + "\t" + c.getMWE()+ "\t"+ type +"\n");
						    				wr.write(c.getLemmaMWE() + "\t" + c.getMWE()+ "\t"+ type +"\n");
						    				wr.flush();
						    				
						    				//wrs.get(str).write(c.getLemmaMWE() + "\t" + c.getMWE()+ "\n");
						    				//wrs.get(str).flush();
						    				
						    				String key = c.getLemmaMWE();

						    				if (constr.containsKey(str)) {
						    					if (constr.get(str).containsKey(key)) {
						    						constr.get(str).put(key,constr.get(str).get(key)+1);
						    					} else {
						    						constr.get(str).put(key,1);
						    					}
						    				}
							    				
						    				chStr1 = chStr1.substring(index+1);
						    				cutAt += index+1;
						    			}
						    		}
						    		
						    	}
						    	
						    	chunk = new Chunk();
						    	chunk.id = ""+currentChunk;
						    	previousChunk = currentChunk;

//						    	i++;
						    }
						    

						    //System.out.println(nodes.getLength()+ "\t" + file.length());
				    		//all += nodes.getLength()-1;


			      }
		    }
			

			     
	    	  for (String str : s){
	    		  
	    		  Writer wr1 = new OutputStreamWriter(new FileOutputStream(mainPath + "/phrases_mwe_candidates_plus1_"+str), "UTF-8");
	    		  
	    		  HashMap<String,Integer> hm = constr.get(str);
	    		  HashMap<String,Integer> freq = new HashMap<String,Integer>();

	    		  for (String key : hm.keySet()) {
		    		
	    			  
	    			  String type = (mweDicts.containsKey(key))? mweDicts.get(key) : "Y";
	    			  
	    			  if (freq.containsKey(type)) {
	    				  freq.put(type, freq.get(type)+hm.get(key));
	    			  } else {
	    				  freq.put(type, hm.get(key));
	    			  }
	    			  
	    			  wr1.write(key+"\t"+type+"\t"+hm.get(key)+"\n");
	    			  wr1.flush();

	    		  }
    				
	    		  wr1.write("\n\n\n");
	    		  for (String t : freq.keySet()) {
	    			  wr1.write(str + "\t" + t + "\t" + freq.get(t)+"\n");
	    			  wr1.flush();

	    			  wr.write(str + "\t" + t + "\t" + freq.get(t)+"\n");
	    			  wr.flush();
	    		  }
	    		  
		    	  wr1.flush();
		    	  wr1.close();

	    		}

	    	  wr.flush();
	    	  wr.close();

			} catch (UnsupportedEncodingException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			} catch (FileNotFoundException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			} catch (SAXException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (ParserConfigurationException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (ClassCastException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (ClassNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (InstantiationException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IllegalAccessException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}


}

public static void tagFromDictionary(String path){
	
    File startingDirectory= new File(path);
    List<File> files = null;
    try{
    	files = getFileListing(startingDirectory);
    	System.out.println(files.size());
    } catch(Exception e){
    	System.err.println("GET listing error");
    }

    int all = 0;
    int currentChunk = 0;
    int previousChunk = 0;

    SyntacticConstructions s = new  SyntacticConstructions();
    Writer wr;
	try {
		wr = new OutputStreamWriter(new FileOutputStream(mainPath + "/forTheTageer/mwe_candidates"), "UTF-8");

    
    for(File file : files ){
	      if (file.isFile()){
	    	  
	    	  
	    	  if (file.getName().startsWith("._")) continue;
	    	  if (file.getName().endsWith("~")) continue;
	    	  
				try {

					DocumentBuilderFactory builderFactory = DocumentBuilderFactory.newInstance();
		    		DocumentBuilder builder = builderFactory.newDocumentBuilder();
		    		Document document = builder.parse(new FileInputStream(file.getAbsolutePath()));
		    		
		    		Element rootElement = document.getDocumentElement();
		    		
			    	DOMImplementationRegistry registry = DOMImplementationRegistry.newInstance();
			    	DOMImplementationLS lsImpl = 
			    	   (DOMImplementationLS)registry.getDOMImplementation("LS");
			    	LSSerializer serializer = lsImpl.createLSSerializer();

			    	NodeList nodes = rootElement.getChildNodes();
				    
				    System.out.println("Processing " + file.getAbsolutePath());
				    
				    
				    int i = 0;
			    	
			    	String chunkStruct = "";
			    	Chunk chunk = new Chunk();

				    while (i<nodes.getLength()) {

				    	WordAlphabetic word = new WordAlphabetic();
				    	
				    	
				   	
				    	while (i<nodes.getLength()  && currentChunk == previousChunk){
				    		
				    		
					    	Node node = nodes.item(i);
					    	
					    	if(node instanceof Element){
					    		
					    		  Element child = (Element) node;
					    		  
					    		  String token = child.getAttribute("w");
					    		  String lemma = child.getAttribute("l");

					    		  String pos = child.getAttribute("pos");
					    		  String sen = child.getAttribute("sen");
					    		  							    		  							    		  
					    		  word = new WordAlphabetic(indexAlphabetical.tokenIndex,indexAlphabetical.lemmaIndex);
					    		  
					    		  int[] inds = indexAlphabetical.addWord(token, lemma);

//					    		  System.out.println(token + "inds: " + inds[0] + "\t" + inds[1] + "\t" + inds[2] + "\t" + inds[3]);

					    		  word.word[0] = inds[0];
					    		  word.word[1] = inds[1];
					    		  word.lemma[0] = inds[2];
					    		  word.lemma[1] = inds[3];
					    		  
					    		  word.pos = pos;
					    		  word.sen = sen;
					    		  currentChunk = Integer.valueOf(sen);
					    	} 
					    	
					    	
					    	i++;
					    	
				    	}
				    	
				    	// process chunk
				    	if (chunk.size() > 1) {
				    		
				    		
				    		String chStr = chunk.getStruct();
				    		String match = "";
				    		System.out.println(chStr);
				    		
				    		for (String str : s){
				    			String chStr1 = chStr;
				    			int cutAt = 0;
				    			
				    			while (chStr1.contains(str)) {
				    				int index = chStr1.indexOf(str);
				    				int length = str.length();
				    				
				    				MWECandidate c = new MWECandidate();
				    				
				    				for (int j = 0; j<length; j++) {
				    					c.phrase.add(chunk.get(cutAt + index + j));
//				    					System.out.println(chunk.id);
//				    					System.out.print(indexAlphabetical.tokenIndex.get(chunk.get(index + j).word[0]).get(chunk.get(index + j).word[1]) + " ");
				    				}
				    				
				    				System.out.println(c.getLemmaMWE() + "\t" + c.getMWE());
				    				wr.write(c.getLemmaMWE() + "\t" + c.getMWE());
				    				wr.flush();
				    				
				    				chStr1 = chStr1.substring(index+1);
				    			}
				    		}
				    		
				    	}
				    	
				    	chunk = new Chunk();
				    	chunk.id = ""+currentChunk;
				    	previousChunk = currentChunk;

//				    	i++;
				    }
				    

				    //System.out.println(nodes.getLength()+ "\t" + file.length());
		    		//all += nodes.getLength()-1;

	    	  wr.flush();
	    	  wr.close();
				    
				} catch (FileNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (SAXException e) {
					// TODO Auto-generated catch block
			    	  System.out.println(file.length());
					e.printStackTrace();
					System.err.println(file.getAbsolutePath());
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (ParserConfigurationException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (ClassCastException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (ClassNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (InstantiationException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IllegalAccessException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}

			
//			      System.exit(0);
	      }
	      
	     
	}
    
	} catch (UnsupportedEncodingException e1) {
		// TODO Auto-generated catch block
		e1.printStackTrace();
	} catch (FileNotFoundException e1) {
		// TODO Auto-generated catch block
		e1.printStackTrace();
	}

    System.err.println("All: " + all);

}


public static void markMWEsInFiles(String path){

    File startingDirectory= new File(path);
    List<File> files = null;
    try{
    	files = getFileListing(startingDirectory);
    	System.out.println(files.size());
    } catch(Exception e){
    	System.err.println("GET listing error");
    }

    int overlap = 0;
    SyntacticConstructions s = new  SyntacticConstructions();
    
    String[] allDomains = new String[]{"Archeology", "Biology", "Chemistry",
    		"Physics","Economics","Philosophy","Geography",
    		"History","Literature","Medicine","Astronomy",
    		"Linguistics","Maths","Sociology","Psychology",
    		"Education","Law","Technology","Politics","Culture",
    		"Architecture","Sport","Military","Popular","Z"};
    
     

   try {
    
    for(File file : files ){
	      if (file.isFile()){
	    	  
	    	  
	    	  if (file.getName().startsWith("._")) continue;
	    	  if (file.getName().endsWith("~")) continue;
	    	  
				try {

					DocumentBuilderFactory builderFactory = DocumentBuilderFactory.newInstance();
		    		DocumentBuilder builder = builderFactory.newDocumentBuilder();
		    		Document document = builder.parse(new FileInputStream(file.getAbsolutePath()));
		    		
		    		Element rootElement = document.getDocumentElement();
		    		
			    	DOMImplementationRegistry registry = DOMImplementationRegistry.newInstance();
			    	DOMImplementationLS lsImpl = 
			    	   (DOMImplementationLS)registry.getDOMImplementation("LS");
			    	LSSerializer serializer = lsImpl.createLSSerializer();

			    	NodeList nodes = rootElement.getChildNodes();
				    
				    System.out.println("Processing " + file.getAbsolutePath());
				    
				    String fname = file.getAbsolutePath().replace("/xml-verified-final/", "/xml-verified-marked-plus1/");
				    makeParent(fname, "/");
				    System.out.println("Saving to " + fname);
				    
				    Writer wr = new OutputStreamWriter(new FileOutputStream(fname), "UTF-8");
				    wr.write("<?xml version=\"1.0\" ?><text current=\"0\">\n");
				    
				    int i = 0;
			    	

			    	WordAlphabetic word = new WordAlphabetic();


newchunk:		    while (i<nodes.getLength()) {

				    	Chunk chunk = new Chunk();
				    	chunk.id = "";
				    	
				    	if (word.pos!=null) {
				    		chunk.add(word);
				    		chunk.id = word.sen;
				    	}
				    	
				    	while (i<nodes.getLength()){
				    		
					    	Node node = nodes.item(i);
					    	
					    	if(node instanceof Element){
					    		
					    		  Element child = (Element) node;
					    		  
					    		  String token = child.getAttribute("w");
					    		  String lemma = child.getAttribute("l");

					    		  String pos = child.getAttribute("pos");
					    		  String sen = child.getAttribute("sen");
					    		  
					    		  if (chunk.id.equals("")) chunk.id = sen;
					    		  
//					    		  System.out.println("CHECK " + token +"\tchunk: "+ chunk.size());
					    		  
				    		  							    		  
					    		  word = new WordAlphabetic(indexAlphabetical.tokenIndex,indexAlphabetical.lemmaIndex);
					    		  
					    		  int[] inds = indexAlphabetical.addWord(token, lemma);

//					    		  System.out.println(token + "inds: " + inds[0] + "\t" + inds[1] + "\t" + inds[2] + "\t" + inds[3]);

					    		  word.word[0] = inds[0];
					    		  word.word[1] = inds[1];
					    		  word.lemma[0] = inds[2];
					    		  word.lemma[1] = inds[3];
					    		  
					    		  word.sen = sen;
					    		  word.pos = pos;

					    		  if (!word.sen.equals(chunk.id)) {
					    			  i++;
					    			  break;
					    		  }


					    		  if (word.pos != null) {
					    			  chunk.add(word);
					    		  }
					    		  
					    		  
					    		  
					    	} 
					    	
					    	
					    	i++;
					    	
				    	}
				    	
				    	// process chunk
				    	if (chunk.size() > 1) {
				    		
				    		
				    		String chStr = chunk.getStruct();
//				    		System.out.println(chStr);
				    		
				    		for (String str : s){
				    			String chStr1 = chStr;
				    			int cutAt = 0;
				    			
constr:				    		while (chStr1.contains(str)) {
				    				int index = chStr1.indexOf(str);
				    				int length = str.length();
				    				
//				    				System.out.println(str + "\t" + chStr1);
				    				
				    				MWECandidate c = new MWECandidate();
				    				
				    				int mwectrpart = 0;
				    				String lemma = "";

				    				for (int j = 0; j<length; j++) {
				    					WordAlphabetic a = chunk.get(cutAt + index + j);
				    					
				    					if (!a.pos.startsWith("P")) {
				    						// a.mwe = mwectr+":"+(mwectrpart++);
				    						lemma += indexAlphabetical.getLemma(a.lemma) + " ";
				    					}
				    					
				    					c.phrase.add(a);
//				    					chunk.set(cutAt+index+j, a);
//				    					System.out.println(chunk.id);
//				    					System.out.print(indexAlphabetical.tokenIndex.get(chunk.get(index + j).word[0]).get(chunk.get(index + j).word[1]) + " ");
				    				}
				    				lemma = lemma.trim();
//				    				System.err.println(lemma + "\t" +mweDicts.containsKey(lemma));
				    				
				    				indexMWE.addWord(lemma, lemma);
				    				
				    				if (mweDicts.containsKey(lemma)) {
					    				for (int j = 0; j<length; j++) {
					    					WordAlphabetic a = chunk.get(cutAt + index + j);

					    					if (a.mwe != null && !a.mwe.equals("")) {
							    				a.mwe += ";";
							    				a.mwe_type += ";";
					    						overlap++;
					    					}

					    					if (!a.pos.startsWith("P")) {
					    						a.mwe += mwectr+":"+(mwectrpart++);
					    						a.mwe_type += mweDicts.get(lemma);
					    					}
					    					
//					    					c.phrase.add(a);
					    					chunk.set(cutAt+index+j, a);
	//				    					System.out.println(chunk.id);
	//				    					System.out.print(indexAlphabetical.tokenIndex.get(chunk.get(index + j).word[0]).get(chunk.get(index + j).word[1]) + " ");
					    				}

					    				mwectr++;
//					    				System.out.println(c.getLemmaMWE() + "\t" + c.getMWE());
				    				}
				    				
				    				chStr1 = chStr1.substring(index+1);
				    				cutAt += index+1;
				    			}
				    		}
				    		
				    		// add chunk to file after all mwes been set
				    		
				    	}

				    	for(WordAlphabetic a : chunk) {
		    				wr.write(a.toXML());
		    				wr.flush();
			    		}

				    	//if (overlap>0) System.exit(-1);
//				    	i++;
				    }
				    

				    //System.out.println(nodes.getLength()+ "\t" + file.length());
		    		//all += nodes.getLength()-1;

			  wr.write("</text>");
	    	  wr.flush();
	    	  wr.close();
	    	  
	    	  System.out.println(overlap);
				    
				} catch (FileNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (SAXException e) {
					// TODO Auto-generated catch block
			    	  System.out.println(file.length());
					e.printStackTrace();
					System.err.println(file.getAbsolutePath());
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (ParserConfigurationException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (ClassCastException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (ClassNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (InstantiationException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IllegalAccessException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}

			
//			      System.exit(0);
	      }
	      
	     
	}

		String fn = mainPath + "/lexicon/MWEfreq-ALL";
		
		indexMWE.printLemmaFreq(fn);

		fn = mainPath + "/lexicon/LEMMAfreq-ALL";
		
		indexAlphabetical.printLemmaFreq(fn);

		fn = mainPath + "/lexicon/TOKENfreq-ALL";
		
		indexAlphabetical.printTokenFreq(fn);

		/**
		String dompath = "/home/ivelina/svn_corpus/forTheTagger/frequencies/";
	    for (String dom : allDomains) {
	    	Writer wr = new OutputStreamWriter(new FileOutputStream(dompath+dom), "UTF-8");

	    	// write freq data
	    	
	    	wr.flush();
	    	wr.close();
	    }
*/
		
	} catch (Exception e){
		
	}


}


public static void findMWEs(String path){

    File startingDirectory= new File(path);
    List<File> files = null;
    try{
    	files = getFileListing(startingDirectory);
    	System.out.println(files.size());
    } catch(Exception e){
    	System.err.println("GET listing error");
    }

    int overlap = 0;
    SyntacticConstructions s = new  SyntacticConstructions();
    
    for(File file : files ){
	      if (file.isFile()){
	    	  
	    	  
	    	  if (file.getName().startsWith("._")) continue;
	    	  if (file.getName().endsWith("~")) continue;
	    	  
				try {

					DocumentBuilderFactory builderFactory = DocumentBuilderFactory.newInstance();
		    		DocumentBuilder builder = builderFactory.newDocumentBuilder();
		    		Document document = builder.parse(new FileInputStream(file.getAbsolutePath()));
		    		
		    		Element rootElement = document.getDocumentElement();
		    		
			    	DOMImplementationRegistry registry = DOMImplementationRegistry.newInstance();
			    	DOMImplementationLS lsImpl = 
			    	   (DOMImplementationLS)registry.getDOMImplementation("LS");
			    	LSSerializer serializer = lsImpl.createLSSerializer();

			    	NodeList nodes = rootElement.getChildNodes();
				    
				    System.out.println("Processing " + file.getAbsolutePath());
				    
				    String fname = file.getAbsolutePath().replace("/xml-verified-final/", "/xml-verified-marked/");
				    makeParent(fname, "/");
				    System.out.println("Saving to " + fname);
				    
				    Writer wr = new OutputStreamWriter(new FileOutputStream(fname), "UTF-8");
				    wr.write("<?xml version=\"1.0\" ?><text current=\"0\">\n");
				    
				    int i = 0;
			    	
			    	String chunkStruct = "";
			    	WordAlphabetic word = new WordAlphabetic();


newchunk:		    while (i<nodes.getLength()) {

				    	Chunk chunk = new Chunk();
				    	chunk.id = "";
				    	
				    	if (word.pos!=null) {
				    		chunk.add(word);
				    		chunk.id = word.sen;
				    	}
				    	
				    	while (i<nodes.getLength()){
				    		
					    	Node node = nodes.item(i);
					    	
					    	if(node instanceof Element){
					    		
					    		  Element child = (Element) node;
					    		  
					    		  String token = child.getAttribute("w");
					    		  String lemma = child.getAttribute("l");

					    		  String pos = child.getAttribute("pos");
					    		  String sen = child.getAttribute("sen");
					    		  
					    		  if (chunk.id.equals("")) chunk.id = sen;
					    		  
//					    		  System.out.println("CHECK " + token +"\tchunk: "+ chunk.size());
					    		  
				    		  							    		  
					    		  word = new WordAlphabetic(indexAlphabetical.tokenIndex,indexAlphabetical.lemmaIndex);
					    		  
					    		  int[] inds = indexAlphabetical.addWord(token, lemma);

//					    		  System.out.println(token + "inds: " + inds[0] + "\t" + inds[1] + "\t" + inds[2] + "\t" + inds[3]);

					    		  word.word[0] = inds[0];
					    		  word.word[1] = inds[1];
					    		  word.lemma[0] = inds[2];
					    		  word.lemma[1] = inds[3];
					    		  
					    		  word.sen = sen;
					    		  word.pos = pos;

					    		  if (!word.sen.equals(chunk.id)) {
					    			  i++;
					    			  break;
					    		  }


					    		  if (word.pos != null) {
					    			  chunk.add(word);
					    		  }
					    		  
					    		  
					    		  
					    	} 
					    	
					    	
					    	i++;
					    	
				    	}
				    	
				    	// process chunk
				    	if (chunk.size() > 1) {
				    		
				    		
				    		String chStr = chunk.getStruct();
				    		System.out.println(chStr);
				    		
				    		for (String str : s){
				    			String chStr1 = chStr;
				    			int cutAt = 0;
				    			
constr:				    		while (chStr1.contains(str)) {
				    				int index = chStr1.indexOf(str);
				    				int length = str.length();
				    				
				    				System.out.println(str + "\t" + chStr1);
				    				
				    				MWECandidate c = new MWECandidate();
				    				
				    				int mwectrpart = 0;
				    				String lemma = "";

				    				for (int j = 0; j<length; j++) {
				    					WordAlphabetic a = chunk.get(cutAt + index + j);
				    					
				    					if (!a.pos.startsWith("P")) {
				    						// a.mwe = mwectr+":"+(mwectrpart++);
				    						lemma += indexAlphabetical.getLemma(a.lemma) + " ";
				    					}
				    					
				    					c.phrase.add(a);
//				    					chunk.set(cutAt+index+j, a);
//				    					System.out.println(chunk.id);
//				    					System.out.print(indexAlphabetical.tokenIndex.get(chunk.get(index + j).word[0]).get(chunk.get(index + j).word[1]) + " ");
				    				}
				    				lemma = lemma.trim();
				    				System.err.println(lemma + "\t" +mweDicts.containsKey(lemma));
				    				if (mweDicts.containsKey(lemma)) {
					    				for (int j = 0; j<length; j++) {
					    					WordAlphabetic a = chunk.get(cutAt + index + j);

					    					if (a.mwe != null && !a.mwe.equals("")) {
							    				a.mwe += ";";
							    				a.mwe_type += ";";
					    						overlap++;
					    					}

					    					if (!a.pos.startsWith("P")) {
					    						a.mwe += mwectr+":"+(mwectrpart++);
					    						a.mwe_type += mweDicts.get(lemma);
					    					}
					    					
//					    					c.phrase.add(a);
					    					chunk.set(cutAt+index+j, a);
	//				    					System.out.println(chunk.id);
	//				    					System.out.print(indexAlphabetical.tokenIndex.get(chunk.get(index + j).word[0]).get(chunk.get(index + j).word[1]) + " ");
					    				}

					    				mwectr++;
					    				System.out.println(c.getLemmaMWE() + "\t" + c.getMWE());
				    				}
				    				
				    				chStr1 = chStr1.substring(index+1);
				    				cutAt += index+1;
				    			}
				    		}
				    		
				    		// add chunk to file after all mwes been set
				    		
				    	}

				    	for(WordAlphabetic a : chunk) {
		    				wr.write(a.toXML());
		    				wr.flush();
			    		}

if (overlap>0) System.exit(-1);
//				    	i++;
				    }
				    

				    //System.out.println(nodes.getLength()+ "\t" + file.length());
		    		//all += nodes.getLength()-1;

			  wr.write("</text>");
	    	  wr.flush();
	    	  wr.close();
	    	  
	    	  System.out.println(overlap);
				    
				} catch (FileNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (SAXException e) {
					// TODO Auto-generated catch block
			    	  System.out.println(file.length());
					e.printStackTrace();
					System.err.println(file.getAbsolutePath());
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (ParserConfigurationException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (ClassCastException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (ClassNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (InstantiationException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IllegalAccessException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}

			
//			      System.exit(0);
	      }
	      
	     
	}
    

}

}
