package bg.bas.dcl.CorpusTools;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Scanner;

import bg.bas.dcl.mwe.entities.Word;
import bg.bas.dcl.mwe.lists.IndexLexicon;
import bg.bas.dcl.mwe.lists.TokenToLemmaLexicon;

public class TaggedToXMLConverter1 {

	static ArrayList<Integer> tokenFrequencyCtr = new ArrayList<Integer>();
	static ArrayList<Integer> lemmaFrequencyCtr = new ArrayList<Integer>();

	static public IndexLexicon tokenLexicon = new IndexLexicon(
			tokenFrequencyCtr);
	static public IndexLexicon lemmaLexicon = new IndexLexicon(
			lemmaFrequencyCtr);

	static TokenToLemmaLexicon tokenToLemmaLexicon = new TokenToLemmaLexicon();

	static long chunkctr = 1;
	static long mwectr = 1;
	static String punct = ".,?!;\"&(){}[]-<>|/\\";
	static ArrayList<String> langs = new ArrayList<String>();
	static HashMap<String,Record> records = new HashMap<String,Record>();

	
	static boolean isSymmetric(String flag) {
		for (int i = 0; i< flag.length()/2; i++) {
			if (!flag.substring(i,i+1).equals(flag.substring(flag.length()-i-1))) return false;
		}
		return true;
	}
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		
		readLangs("/home/ivelina/CORPORA/resources/langs-wikipedia.txt");
		readRecords("/home/ivelina/svn_corpus/forTheTagger/corpus_data.txt");
		System.out.println(records.size());

		String pathOriginal = args[0];
		String pathTagged = args[1];
		String outpath = args[2];

		File startingDirectory = new File(pathOriginal);
		List<File> files = null;
		try {
			files = getFileListing(startingDirectory);
			System.out.println(files.size());
		} catch (Exception e) {
			System.err.println("GET listing error");
		}

		if (files == null) {
			System.err.println("Listing error " + pathTagged);
			System.exit(-1);
		}

		try {

			/**
			Writer mwes = new OutputStreamWriter(new FileOutputStream(args[3]),
			"UTF-8");
			Writer translated = new OutputStreamWriter(new FileOutputStream(args[5]),
			"UTF-8");
			*/
			
			Writer log = new OutputStreamWriter(new FileOutputStream(args[3]),
			"UTF-8");


			fileloop: for (File file : files) {
				if (file.isFile()) {

					if (file.getName().startsWith("._"))
						continue;
					if (file.getName().endsWith("~"))
						continue;

					String filename = file.getAbsolutePath();
					
					System.out.println(filename);

					String taggedname = pathTagged
							+ filename.substring(pathOriginal.length());
					String toname = outpath
							+ filename.substring(pathOriginal.length());

					try {

						makeParent(toname, outpath);
						log.write(file.getAbsolutePath() + "\n");
						log.flush();

						Scanner st = new Scanner(new File(taggedname), "UTF-8");

						Writer out = new OutputStreamWriter(
								new FileOutputStream(toname), "UTF-8");

						out.write("<?xml version=\"1.0\" ?><text current=\"0\">");
						out.flush();

						
						int sqbrackets = 0;
						int cbrackets = 0;
						boolean remove = false;
						ArrayList<String> contents = new ArrayList<String>();


		lineloop:       while (st.hasNextLine()) {
							String line = st.nextLine();

							String[] words = line.split("[ \t]");
							ArrayList<String> words1 = new ArrayList<String>();

//							log.write(line + "\nNum words: " + words.length
//									+ "\n");
//							log.flush();
							
							if (line.contains("'''")) continue;

							String pre = "";
							
							if (words[2].equals("M")) {
							
								while (words[0].length()>0) {
									
									String sym = words[0].substring(0, 1);
//									log.write("Check: " + sym +"\n");
									
									if (punct.contains(sym)) {
										if (pre.length()>0) {
											words1.add(pre);
											words1.add(pre);
											words1.add("M");
											pre = "";
										}
										words1.add(sym);
										words1.add(sym);
										words1.add("U");
									} else {
										pre += sym;
									}
									words[0] =  words[0].substring(1);
								}
								
								if (pre.length()>0) {
									
//									log.write("With punct: " + pre);
									
									words1.add(pre);
									words1.add(pre);
									words1.add("M");
									pre = "";
								}

							} else {
								words1.add(words[0]);
								words1.add(words[1]);
								words1.add(words[2]);

							}
							
							
							
							
							for (int i = 0; i < words1.size()/3; i++) {
								String w0 = words1.get(3*i);
								String w1 = words1.get(3*i+1);
								String w2 = words1.get(3*i+2);
								
//								log.write(sqbrackets + "\t"+w0 + "\t" + w1 + "\t" + w2+"\n");

								
								if (w0.equals("[")) {
									sqbrackets++;
									continue;
								}
								if (w0.equals("{")) {
									cbrackets++;
									continue;
								}

								if (w0.equals("]")) {
									sqbrackets--;
								}
								
								if (w0.equals("}")) {
									cbrackets--;
								}
								
								if (cbrackets==2
										&& (w0
												.equalsIgnoreCase("Категория")
												|| w0
												.equalsIgnoreCase("Файл") || w0
												.equalsIgnoreCase("Шаблон") || w0
												.equalsIgnoreCase("Картинка") || w0
												.equalsIgnoreCase("File")|| w0
												.equalsIgnoreCase("Image"))) {
									remove = true;
								}

								
								if (cbrackets == 0 && sqbrackets == 0){
									

									
									if (contents.size() > 0) {
										if (contents.contains("|")) {
											if (contents.lastIndexOf("|") - contents.indexOf("|") > 1) { 
												remove = true;
											}
										}
										

										if (remove) {
											remove = false;
											contents = new ArrayList<String>();
											continue;
										}
										
										boolean t = false;
										// empty into file
										for (int j = 0; j < contents.size()/3; j++) {
											if (!t && contents.contains("|")) {
												j = contents.lastIndexOf("|")/3+1;
												t=true;
											}
											
											if (j == contents.size()/3) break;
											
											Word w = new Word(tokenLexicon,
													lemmaLexicon);
											w.word = tokenLexicon
													.addEntry(contents.get(3*j));
											w.lemma = lemmaLexicon
													.addEntry(contents.get(3*j+1));
	
											w.sen = String
													.valueOf(chunkctr);
											w.pos = contents.get(3*j+2);
	
											if (w2.equals("U"))
												chunkctr++;
	
											out.write(w.toXML());
											out.flush();
										}
										contents = new ArrayList<String>();
										
									}
									
									if (w0.equals("}") || w0.equals("]")) continue;
									
									Word w = new Word(tokenLexicon,
											lemmaLexicon);
									w.word = tokenLexicon
											.addEntry(w0);
									w.lemma = lemmaLexicon
											.addEntry(w1);

									w.sen = String
											.valueOf(chunkctr);
									w.pos = w2;

									if (w2.equals("U"))
										chunkctr++;

									out.write(w.toXML());
									out.flush();

								} else {

									if (w0.equals("}") || w0.equals("]")) continue;

									contents.add(w0);
									contents.add(w1);
									contents.add(w2);
//									log.write("NOT 00: " + "\t"+contents.get(0) + "\t" + contents.get(1) + "\t" + contents.get(2)+"\n");
								}
								
								
							}
							

						} // end scanner s readline loop
						st.close();

						out.write("</text>");
						out.flush();
						out.close();

						log.write("CORRECT" + file.getAbsolutePath()
								+ "\nTokens: " + tokenLexicon.size()
								+ ", Lemmas: " + lemmaLexicon.size());
						log.flush();

					} catch (Exception e) {
						e.printStackTrace();

					}
					// System.exit(-1);
				}
			}
			log.write("\nTokens: " + tokenLexicon.size()
					+ ", Lemmas: " + lemmaLexicon.size());
			log.flush();
			log.flush();
			log.close();
			
		} catch (Exception e) {
			e.printStackTrace();
		} finally {

		}
	}
	
	static void readLangs(String filename){
		
		try{
			BufferedReader inData = new BufferedReader(new FileReader(filename));
			
			while (inData.ready()){
				String line = inData.readLine();
				line = line.trim();	
				
				if (!line.equalsIgnoreCase("")) langs.add(line);
			
			}
			
			inData.close();
			
			System.out.println(langs.size());
			
		} catch (FileNotFoundException fnfe) {
			System.err.println(fnfe.getMessage());
		} catch (IOException ioe) {
			System.err.println(ioe.getMessage());
		}
	}

	static void readRecords(String filename){
		
		try{
			BufferedReader inData = new BufferedReader(new FileReader(filename));
			
			while (inData.ready()){
				String line = inData.readLine();
				line = line.trim();	
				Record rec = new Record();
				rec = rec.readRecord(line);
				
				String key = rec.getAttribute("filename").substring(rec.getAttribute("filename").lastIndexOf("/")+1);
				if (!line.equalsIgnoreCase("")) records.put(key,rec);
			
			}
			
			inData.close();
			
		} catch (FileNotFoundException fnfe) {
			System.err.println(fnfe.getMessage());
		} catch (IOException ioe) {
			System.err.println(ioe.getMessage());
		}
	}

	/**
	 * Recursively walk a directory tree and return a List of all Files found;
	 * the List is sorted using File.compareTo().
	 * 
	 * @param aStartingDir
	 *            is a valid directory, which can be read.
	 */
	static public List<File> getFileListing(File aStartingDir)
			throws FileNotFoundException {
		validateDirectory(aStartingDir);
		List<File> result = getFileListingNoSort(aStartingDir);
		Collections.sort(result);
		return result;
	}

	// PRIVATE //
	static private List<File> getFileListingNoSort(File aStartingDir)
			throws FileNotFoundException {
		List<File> result = new ArrayList<File>();
		File[] filesAndDirs = aStartingDir.listFiles();
		List<File> filesDirs = Arrays.asList(filesAndDirs);
		for (File file : filesDirs) {
			result.add(file); // always add, even if directory
			if (!file.isFile()) {
				// must be a directory
				// recursive call!
				List<File> deeperList = getFileListingNoSort(file);
				result.addAll(deeperList);
			}
		}
		return result;
	}

	/**
	 * Directory is valid if it exists, does not represent a file, and can be
	 * read.
	 */
	static private void validateDirectory(File aDirectory)
			throws FileNotFoundException {
		if (aDirectory == null) {
			throw new IllegalArgumentException("Directory should not be null.");
		}
		if (!aDirectory.exists()) {
			throw new FileNotFoundException("Directory does not exist: "
					+ aDirectory);
		}
		if (!aDirectory.isDirectory()) {
			throw new IllegalArgumentException("Is not a directory: "
					+ aDirectory);
		}
		if (!aDirectory.canRead()) {
			throw new IllegalArgumentException("Directory cannot be read: "
					+ aDirectory);
		}
	}

	static void makeParent(String path, String mainPath) {
		String parent = (new File(path)).getParent();

		if ((new File(parent)).exists())
			return;

		if (!parent.equals(mainPath)) {
			makeParent(parent, mainPath);
		}

		(new File(parent)).mkdir();

	}

}
