package bg.bas.dcl.CorpusTools;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Reader;
import java.io.UnsupportedEncodingException;
import java.io.Writer;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Scanner;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.apache.commons.codec.binary.Hex;
import org.apache.http.HeaderElement;
import org.apache.http.HeaderElementIterator;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.cookie.Cookie;
import org.apache.http.impl.client.AbstractHttpClient;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicHeaderElementIterator;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.xml.sax.SAXException;

import bg.bas.dcl.mwe.lists.IndexLexicon;


public class WikipediaTagger {
	
    static String NL = System.getProperty("line.separator");
	static String mainPath = "/home/ivelina/CORPORA/";
	String outFolder = mainPath + "WikipediaCorpus3/";
	String inFolder = mainPath + "WikipediaCorpus/";
	String corpusData = outFolder + "corpus_data.txt";
	String mweData = outFolder + "mwes_";
	
	long mwectr = 0;
	long mwectr_limit = 50000;
	long filectr = 6;
	
	long from = 0;
	
	
	String cLetters = "0123456789АБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЬЮЯ";
	String lLetters = "абвгдежзийклмнопрстуфхцчшщъьюя";
	String clLetters = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
	String llLetters = "abcdefghijklmnopqrstuvwxyz";
	
	String allLetters = cLetters + lLetters + clLetters + llLetters;
	String bgLetters = cLetters + lLetters;
	String enLetters = clLetters + llLetters;
	
	static private String domainFileName = mainPath + "resources/domains-wikipedia-keywords.txt";
	static HashMap<String, String> domainKeywords = new HashMap<String, String>();

	static String structFile = "/home/ivelina/CORPORA/resources/structure.txt";
	static HashMap<String, String> styles = new HashMap<String, String>();
	static HashMap<String, HashMap<String, String>> genres = new HashMap<String, HashMap<String, String>>();
	static HashMap<String, HashMap<String, ArrayList<String>>> domains = new HashMap<String, HashMap<String, ArrayList<String>>>();

	static IndexLexicon MWELexicon = new IndexLexicon();
	static HashMap<Integer, ArrayList<String>> mwes = new HashMap<Integer, ArrayList<String>>();
	
	ArrayList<String> langs = new ArrayList<String>();
	ArrayList<String> langs_selected = new ArrayList<String>();
	
	  public HashMap<String,String> dict = new HashMap<String,String>();
	

	public void saveToFile(String text, String encoding, String filename){

		String path = outFolder;
		
	    try{

	    
			path = path.concat(filename);
	    
			
	      
			System.out.println (path);
//			if ((new File(path)).exists()) return;

			makeParent(path);

			Writer out = new OutputStreamWriter(new FileOutputStream(path),encoding);
	      
	 	    out.write(text);
	 	    out.flush();
	 	    out.close();
 	    

	    } catch(Exception e) {
	    	System.err.println(e.getMessage());  
	    }
		
	}


	static void makeParent(String path){
		  String parent = (new File(path)).getParent();
		 
		  if ((new File(parent)).exists()) return;
		  
		  if (!parent.equals(mainPath)) {
			  makeParent(parent);
		  } 
		  
		  (new File(parent)).mkdir();
		  
	}
	
	void readLangs(){
		
		try{
			BufferedReader inData = new BufferedReader(new FileReader(mainPath + "resources/langs-wikipedia.txt"));
			
			while (inData.ready()){
				String line = inData.readLine();
				line = line.trim();	
				
				if (!line.equalsIgnoreCase("")) langs.add(line);
			
			}
			
			inData.close();
			System.out.println(langs.size());
			
// in case you work with a limited number of languages, put them in langs_selected			
			langs_selected.add("bg");
//			langs_selected.add("en");
			
			
		} catch (FileNotFoundException fnfe) {
			System.err.println(fnfe.getMessage());
		} catch (IOException ioe) {
			System.err.println(ioe.getMessage());
		}
	}
	

	/** Read the contents of the given file. */
	static void readDomainKeywordsFromFile() throws IOException {

		String NL = System.getProperty("line.separator");
		Scanner scanner = new Scanner(new File(domainFileName), "UTF-8");

		if (scanner.equals(null))
			return;

		System.out.println("Scanner created");

		try {
			while (scanner.hasNextLine()) {
				String rec = scanner.nextLine();
				rec = rec.trim();
				if (rec.length() < 2)
					continue;
				if (rec.charAt(0) == '#')
					if (rec.substring(1).trim().equalsIgnoreCase("end"))
						break;
					else
						continue;
				String[] entry = rec.split("\t");
				if (entry.length != 2)
					continue;

				domainKeywords.put(entry[0].trim(), entry[1].trim());
			}

		} finally {
			scanner.close();
		}
	}

	
	  
		/** Read the contents of the given file. */
		static void readStructureFromFile() throws IOException {

			String NL = System.getProperty("line.separator");
			Scanner scanner = new Scanner(new File(structFile), "UTF-8");

			if (scanner.equals(null))
				return;

			System.out.println("Scanner created from " + structFile);

			try {
				while (scanner.hasNextLine()) {
					String rec = scanner.nextLine();
					rec = rec.trim();

					if (rec.length() < 1) {
						continue;
					}

					if (rec.charAt(0) == '#') {
						if (rec.substring(1).trim().equalsIgnoreCase("end"))
							break;
						else
							continue;
					}

					String[] entry = rec.split("\t");

					// style
					if (entry.length == 2) {
						styles.put(entry[0], entry[1]);
						continue;
					}

					if (entry.length == 3) {
						HashMap<String, String> d;
						if (genres.containsKey(entry[0]))
							d = genres.get(entry[0]);
						else
							d = new HashMap<String, String>();
						d.put(entry[1], entry[2]);
						genres.put(entry[0], d);
						continue;
					}

					if (entry.length == 4) {
						HashMap<String, ArrayList<String>> d;
						if (domains.containsKey(entry[0]))
							d = domains.get(entry[0]);
						else
							d = new HashMap<String, ArrayList<String>>();

						ArrayList<String> c = new ArrayList<String>();
						c.add(entry[2]);
						c.add(entry[3]);
						d.put(entry[1], c);
						domains.put(entry[0], d);
						continue;
					}

					System.err
							.println("Line in structure.txt not correct. Ignore...");

				}

			} finally {
				scanner.close();
			}
		}


	  void extractMWEs(String word, Writer out, boolean vert) {
		  
		  
		  System.out.println(word);
		  
		  if (vert) {
			  String[] words = word.split("\\|");					  
			  
		  
			  String lemma = words[0].trim();
			  String form = words[1].trim();
			  
			  if (lemma.split(" ").length > 1 || form.split(" ").length > 1) {
				  try{
					  out.write(lemma + "\t" + form + NL);
					  out.flush();
					  mwectr ++;
				  } catch (IOException ioe) {
					  System.err.println(ioe.getStackTrace());

				  }
			  }
				  
		  } else {
			  if (word.split(" ").length > 1) {
				  try{
					  out.write(word.trim() + NL);
					  out.flush();
					  mwectr ++;
				  } catch (IOException ioe) {
					  System.err.println(ioe.getStackTrace());

				  }
			  }

		  }
		  
	  }
	  /**
	   * Recursively walk a directory tree and return a List of all
	   * Files found; the List is sorted using File.compareTo().
	   *
	   * @param aStartingDir is a valid directory, which can be read.
	   */
	   static public List<File> getFileListing(
	     File aStartingDir
	   ) throws FileNotFoundException {
	     validateDirectory(aStartingDir);
	     List<File> result = getFileListingNoSort(aStartingDir);
	     Collections.sort(result);
	     return result;
	   }

	   // PRIVATE //
	   static private List<File> getFileListingNoSort(
	     File aStartingDir
	   ) throws FileNotFoundException {
	     List<File> result = new ArrayList<File>();
	     File[] filesAndDirs = aStartingDir.listFiles();
	     List<File> filesDirs = Arrays.asList(filesAndDirs);
	     for(File file : filesDirs) {
	       result.add(file); //always add, even if directory
	       if ( ! file.isFile() ) {
	         //must be a directory
	         //recursive call!
	         List<File> deeperList = getFileListingNoSort(file);
	         result.addAll(deeperList);
	       }
	     }
	     return result;
	   }

	   /**
	   * Directory is valid if it exists, does not represent a file, and can be read.
	   */
	   static private void validateDirectory (
	     File aDirectory
	   ) throws FileNotFoundException {
	     if (aDirectory == null) {
	       throw new IllegalArgumentException("Directory should not be null.");
	     }
	     if (!aDirectory.exists()) {
	       throw new FileNotFoundException("Directory does not exist: " + aDirectory);
	     }
	     if (!aDirectory.isDirectory()) {
	       throw new IllegalArgumentException("Is not a directory: " + aDirectory);
	     }
	     if (!aDirectory.canRead()) {
	       throw new IllegalArgumentException("Directory cannot be read: " + aDirectory);
	     }
	   }


		  
		  /** Read the contents of the given file. */
		  void readDictionaryFromFile(String filename) throws IOException {
			  
		    String NL = System.getProperty("line.separator");
		    Scanner scanner = new Scanner(new File(filename), "UTF-8");
		    
		    if (scanner.equals(null)) return;
		    
		    System.out.println("Scanner created");
		    
		    try {
		      while (scanner.hasNextLine()){
		        String rec = scanner.nextLine();
		        rec = rec.trim();
		        if (rec.length() < 2) continue;
		        if (rec.charAt(0) == '#') 
		        	if (rec.substring(1).trim().equalsIgnoreCase("end")) break;
		        	else continue;
		        String[] entry = rec.split("\t");
		        if (entry.length != 2) continue;
		        
		        dict.put(entry[0],entry[1]);
		      }
		      	      
		    }
		    finally{
		     scanner.close(); 
		    }
		    log("Dictionary read in ");
		  }

		  private void log(String aMessage){
			    System.out.println(aMessage);
			  }
		  
	public static void main (String[] args) throws Exception{
		
		WikipediaTagger wd = new WikipediaTagger();
		
		wd.readDictionaryFromFile(mainPath + "resources/bg-en-dict.txt");
		wd.readLangs();
		readDomainKeywordsFromFile();
		readStructureFromFile();
		


//	    reduceMWEs(args[0]);
	    tagReducedMWEs(args[1]);


	}
	
	public static void reduceMWEs(String startingFolder)  throws Exception{
		
	    File startingDirectory= new File(startingFolder);
	    
	    if (!startingDirectory.exists()) return;
	    	
	    List<File> files = getFileListing(startingDirectory);

	    int ctr = 0;
	    boolean begin = false;

		fileloop:		    
			for(File file : files ){
				 if (!file.isFile()) continue;
		      if (file.isFile()){
		    	  
		    	  if (file.getAbsolutePath().endsWith("~")) continue;
		    	  Scanner in = new Scanner (file, "UTF-8");
		    	  
		    	  
//		    	  String outname = file.getAbsolutePath().replace("/bg/", "/bg-tagged/");
		    	  String outname = file.getAbsolutePath().replace("/bg/", "/bg-reduced/");
		    	  makeParent(outname);
		  		  Writer out = new OutputStreamWriter(new FileOutputStream(outname,false),"UTF-8");

		    	  String text = "";
		    	  
		    	  while (in.hasNextLine()) {
		    		  
		    		  text = in.nextLine(); 
		    		  String[] entries = text.split("\t");
		    		  
		    		  if (entries.length != 2) continue;
		    		  
		    		  String key = entries[0].trim().toLowerCase();
		    		  String value = entries[1].trim().toLowerCase();

		    		  if (key.length() == 0 || value.length() == 0) continue;
		    		  
//		    		  if (text.startsWith("ФК Гагра")) begin = true;
//		    		  if (! begin) continue;
		    		  
		    		  System.out.println(text);
		    		  Integer key_i = MWELexicon.addEntry(key);
		    		  
		    		  ArrayList<String> forms; 
		    		  
		    		  if (mwes.containsKey(key_i)) forms = mwes.get(key_i);
		    		  else forms = new ArrayList<String>();
		    		  
		    		  if (!forms.contains(value)) forms.add(value);
		    		  
		    		  mwes.put(key_i, forms);
		    		  
		/**    		  
		    		  //+ " END" + NL;

		    		  
		    		  
		    		  //	    		  text = text.replace("\t", "\t")
		    	  
		        	String formURL = "http://dcl.bas.bg/services/";
		        	

		        	
		            HttpClient httpclient = new DefaultHttpClient();
		            try {
		                
		                System.out.println("Initial set of cookies:");
		                List<Cookie> cookies = ((AbstractHttpClient) httpclient).getCookieStore().getCookies();
		                if (cookies.isEmpty()) {
		                    System.out.println("None");
		                } else {
		                    for (int i = 0; i < cookies.size(); i++) {
		                        System.out.println("- " + cookies.get(i).toString());
		                    }
		                }
		                
		               List<NameValuePair> formparams = new ArrayList<NameValuePair>();

		               formparams.add(new BasicNameValuePair("text", text));
		               formparams.add(new BasicNameValuePair("submit", "submit"));
		               
		                               
		                UrlEncodedFormEntity entity = new UrlEncodedFormEntity(formparams, "UTF-8");
		                HttpPost httppost = new HttpPost("http://dcl.bas.bg/services/tagger.php");
		                httppost.setEntity(entity);

		                
		                HttpResponse response1 = httpclient.execute(httppost);

		                System.out.println(response1.getStatusLine());
		                
		               
		               HeaderElementIterator it = new BasicHeaderElementIterator(response1.headerIterator());

		            		while (it.hasNext()) {
		            		    HeaderElement elem = it.nextElement(); 
		            		    System.out.println(elem.getName() + " = " + elem.getValue());
		            		    NameValuePair[] params = elem.getParameters();
		            		    for (int i = 0; i < params.length; i++) {
		            		        System.out.println(" " + params[i]);
		            		    }
		            		}
		            		
		            		HttpEntity myEntity = response1.getEntity();
		            		System.out.println(myEntity.getContentType());
		            		System.out.println(myEntity.getContentLength());
		            		System.out.println(EntityUtils.getContentCharSet(myEntity));
//		            		System.out.println(EntityUtils.toString(myEntity));
		                 
		                System.out.println("Post logon cookies:");
		                cookies = ((AbstractHttpClient) httpclient).getCookieStore().getCookies();
		                if (cookies.isEmpty()) {
		                    System.out.println("None");
		                } else {
		                    for (int i = 0; i < cookies.size(); i++) {
		                        System.out.println("- " + cookies.get(i).toString());
		                    }
		                }
		                
		                String result = EntityUtils.toString(myEntity);
		        		
		        		InputStream is = new ByteArrayInputStream(result.getBytes());
		        		 
		        		// read it with BufferedReader
		        		BufferedReader br = new BufferedReader(new InputStreamReader(is));

		                String line;
	readline:   		while ((line = br.readLine()) != null) {
								System.out.println(line);
								out.write(line + NL);
		                }
		           		
		                httppost.abort();
		            
		            } finally {
		                // When HttpClient instance is no longer needed,
		                // shut down the connection manager to ensure
		                // immediate deallocation of all system resources
		 
		            	httpclient.getConnectionManager().shutdown();
		            
		            }
		 */
		    	  }
		    	  
		    	  for (Integer key : mwes.keySet()) {
		    		  out.write(MWELexicon.get(key));
		    		  ArrayList<String> forms = mwes.get(key);
		    		  
		    		  for (String value : forms) out.write("\tEND\t" + value);
		    		  
		    		  out.write("\tENDLINE" + NL);
		    		  out.flush();
		    	  }

		            in.close();
		            out.flush();
		            out.close();
		      }
			}

	}
	
	
	public static void tagReducedMWEs(String startingFolder)  throws Exception{
		
	    File startingDirectory= new File(startingFolder);
	    
	    if (!startingDirectory.exists()) return;
	    	
	    List<File> files = getFileListing(startingDirectory);

	    int ctr = 0;

	    boolean start = false;
		fileloop:		    
			for(File file : files ){
		    	  if (file.getAbsolutePath().endsWith("~")) continue;

		    	  if (!file.isFile()) continue;
		      if (file.isFile()){
		    	  
		    	  Scanner in = new Scanner (file, "UTF-8");
		    	  
		    	  String outname = file.getAbsolutePath().replace("/bg/", "/bg-tagged/");
//		    	  String outname = file.getAbsolutePath().replace("/bg/", "/bg-reduced/");
		    	  makeParent(outname);
		  		  Writer out = new OutputStreamWriter(new FileOutputStream(outname,true),"UTF-8");

		    	  String text = "";
		    	  
		    	  while (in.hasNextLine()) {
		    		  
		    		  text = "";
		    		  for (int i = 0; i < 1000; i++){
		    				 if(in.hasNextLine())  text += in.nextLine()+NL; 
		    		  }
		    		  
		    		  System.out.println(text);

		    	  
		        	String formURL = "http://dcl.bas.bg/services/";
		        	
//if (text.startsWith("исаак")) start = true;

//if (!start) continue;
		        	
		            HttpClient httpclient = new DefaultHttpClient();
		            try {
		                
		                System.out.println("Initial set of cookies:");
		                List<Cookie> cookies = ((AbstractHttpClient) httpclient).getCookieStore().getCookies();
		                if (cookies.isEmpty()) {
		                    System.out.println("None");
		                } else {
		                    for (int i = 0; i < cookies.size(); i++) {
		                        System.out.println("- " + cookies.get(i).toString());
		                    }
		                }
		                
		               List<NameValuePair> formparams = new ArrayList<NameValuePair>();

		               formparams.add(new BasicNameValuePair("text", text));
		               formparams.add(new BasicNameValuePair("submit", "submit"));
		               
		                               
		                UrlEncodedFormEntity entity = new UrlEncodedFormEntity(formparams, "UTF-8");
		                HttpPost httppost = new HttpPost("http://dcl.bas.bg/services/tagger.php");
		                httppost.setEntity(entity);

		                
		                HttpResponse response1 = httpclient.execute(httppost);

		                System.out.println(response1.getStatusLine());
		                
		               
		               HeaderElementIterator it = new BasicHeaderElementIterator(response1.headerIterator());

		            		while (it.hasNext()) {
		            		    HeaderElement elem = it.nextElement(); 
		            		    System.out.println(elem.getName() + " = " + elem.getValue());
		            		    NameValuePair[] params = elem.getParameters();
		            		    for (int i = 0; i < params.length; i++) {
		            		        System.out.println(" " + params[i]);
		            		    }
		            		}
		            		
		            		HttpEntity myEntity = response1.getEntity();
		            		System.out.println(myEntity.getContentType());
		            		System.out.println(myEntity.getContentLength());
		            		System.out.println(EntityUtils.getContentCharSet(myEntity));
//		            		System.out.println(EntityUtils.toString(myEntity));
		                 
		                System.out.println("Post logon cookies:");
		                cookies = ((AbstractHttpClient) httpclient).getCookieStore().getCookies();
		                if (cookies.isEmpty()) {
		                    System.out.println("None");
		                } else {
		                    for (int i = 0; i < cookies.size(); i++) {
		                        System.out.println("- " + cookies.get(i).toString());
		                    }
		                }
		                
		                String result = EntityUtils.toString(myEntity);
		        		
		        		InputStream is = new ByteArrayInputStream(result.getBytes());
		        		 
		        		// read it with BufferedReader
		        		BufferedReader br = new BufferedReader(new InputStreamReader(is));

		                String line;
	readline:   		while ((line = br.readLine()) != null) {
								System.out.println(line);
								out.write(line + NL);
		                }
		           		
		                httppost.abort();
		            
		            } finally {
		                // When HttpClient instance is no longer needed,
		                // shut down the connection manager to ensure
		                // immediate deallocation of all system resources
		 
		            	httpclient.getConnectionManager().shutdown();
		            
		            }
		    	  }
		    	  

		            in.close();
		            out.flush();
		            out.close();
		      }
			}

	}

	
}
